
var LeftBar = {
		
	createNew : function(options){
		
		var bars = [];
		
		var currentBarIndex = 0;
		
		if(options.currentBarIndex)
			currentBarIndex = options.currentBarIndex;
		
		function handleData(data){
			if(data.currentBarIndex)
				currentBarIndex = data.currentBarIndex;
			$.each(data.bars,function(i,n){
				if(!n.pcode){
					bars.push(n);
				}else{
					$.each(bars,function(j,d){
						if(d.code==n.pcode){
							if(!d.buttons){
								d.buttons = [];
							}
							d.buttons.push(n);
						}
					});
				}
			});
		}
		
		var showbar = function(barIndex,wrapper){
			
			var bar = bars[barIndex];
			
			if(!bar.buttons){
				return;
			}
			
			var buttonsLength = bar.buttons.length;
		
			var display = "none";
		
			if(barIndex==currentBarIndex){
				display = "";
			}
		
			for (var i = 0; i < buttonsLength; i++) {
		
				var button = bar.buttons[i];
			
				var table = $("<table>",{
					id:'s'+barIndex+i,
					cellspacing : 0,
					cellpadding : 0,
					target:button.target,
					url:button.url,
					'class':'leftbar-button',
					width:'100%'
				});
			
				table.attr("barindex",barIndex);
				table.attr("buttonindex",i);
				table.attr("status",button.status);
				table.css("display",display);
			
				table.mouseenter(function(){
					var barIndex = $(this).attr("barIndex");
					var status = $(this).attr("status");
					$(this).find("img").addClass("mouseon");
					window.status = button.status;
				});
			
				table.mouseleave(function(){
					$(this).find("img").removeClass("mouseon");
					window.status = "";
				});
			
				table.click(function(){
					$(".leftbar-img").removeClass("clicked");
					$(this).find(".leftbar-img").addClass("clicked");
					var url = $(this).attr("url");
					var target = $(this).attr("target");
					window.open(url, target, "toolbar=yes, location=yes, status=yes, menubar=yes, scrollbars=yes, resizable=yes");
				});
			
				var tr = $("<tr>");
			
				table.append(tr);
			
				var td = $("<td>");
				tr.append(td);
			
				var img = $("<img>",{
					src : button.ico,
					'class' : "leftbar-img",
					width:"64",
					height:'54'
				});
				td.append(img);
			
				var text = button.text;
			
				var trText = $("<tr>");
				table.append(trText);
			
				var tdText = $("<td>",{text:text});
				trText.append(tdText);
			
				wrapper.append(table);
			
			};
			
			
		};
		
		var clickOnBar = function(index){
			
			if(index==currentBarIndex){
				return;
			}
	
			var barSize = bars.length;
	
			$(".tab").each(function(){
				var barId = getBarId(this);
				if(barId<=index){
					$(this).appendTo($("#header"));
				}else{
					
					$(this).appendTo($("#footer"));
					
				}
			});
			currentBarIndex = index;
			displayButton(index);
		};
		
		var displayButton = function(index){
			$(".leftbar-button").hide();
			$(".leftbar-button").each(function(){
				var barIndex = $(this).attr("barindex");
				if(barIndex == index){
					$(this).show();
				}
			});
		};
		
		var getBarId = function(bar){
			var tableid = bar.id;
			var index = parseInt(tableid.substr(5,6));
			return index;
		};
		
		if(options.url){
			$.ajax({
				url : options.url,
				data : options.data,
				async : false,
				success: function(data){
					handleData(data);
				},
				dataType:'json'
			});
		}

		var numBar = bars.length;
		
		if(isNaN(currentBarIndex) || currentBarIndex > numBar-1){
			currentBarIndex = 0;
		}
	
		var target = $("#"+options.target);
	
		var i = 0;
		
		// һDiv
		var header = $("<div>",{
			id:'header',
			width:'100%'
			
		});
		
		$("body").prepend(header);
		
		// һõ׵Div
		var footer = $("<div>",{
			id:'footer',
			width:'100%'
		});
		footer.css("position","absolute");
		footer.css("bottom","0");
		
		$("body").append(footer);
	
		for (i = 0; i < numBar; i++) {
	
			var text = bars[i].text;
	
			var table= $("<table>",{
				id : "table"+i,
				'class':'tab',
				border:'1px',
				bordercolorlight:'#808080',
				bordercolordark:'#FFFFFF',
				cellpadding : 1,
				cellspacing : 0 
			});
			
			
			if(i>currentBarIndex){
				table.appendTo(footer);
			}else{
				table.appendTo(header);
			}
			
			var tr = $("<tr>");
			table.append(tr);
		
			var td = $("<td>",{text:text});
			tr.append(td);
		
			table.click(function(){
				clickOnBar(getBarId(this));
			});
		
			table.mouseenter(function(){
				$(this).css("color","blue");
			});
		
			table.mouseleave(function(){
				$(this).css("color","");
			});
		
		}
	
		target.append($("<table height=7><tr><td></td></tr></table>"));
		
		// var buttonsDivHeight = $(document).height()-numBar*20-10;
		
		var buttonsDiv = $("<div>",{
			id : 'buttonsDiv',
			height:'100%'
		});
		
		buttonsDiv.css("overflow","auto");
		
		target.append(buttonsDiv);
	
		for (var i = 0; i < numBar; i++) {
			var bar = bars[i];
			showbar(i,buttonsDiv);
		}
		
	}
};


